/**
 * LOGICAL-PARADOX.ORG variable record manager library
 * Copyright (C)2004 satoshi akabane(akabane@logical-paradox.org)
 *
 * Release 1.0
 * Ep[W
 */
package org.logical_paradox.common.vrm;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;

import org.logical_paradox.common.io.ByteStream;

/**
 * p\XgŎgp郌R[h
 * 
 * @author satoshi akabane@logical-paradox.org
 * @version 1.0
 */
public class AvailableRecord extends Record implements Comparable {
	/**
	 * RXgN^
	 * @param size f[^R[h̃TCY
	 * @param nextptr ̗p\R[h̃oCgψ
	 */
	public AvailableRecord(int size, long nextptr) {
		o = new AvailableRecordByteStream(size, nextptr);
	}
	/**
	 * IuWFNgm̑召r
	 * @param rΏۃIuWFNg
	 * @return 1:this > arg0 0:this == arg0 -1:this < arg0
	 */
	public int compareTo(Object arg0) {
		AvailableRecord r = (AvailableRecord)arg0;

		if(getRecordSize() > r.getRecordSize()) {
			return 1;
		} else if(getRecordSize() < r.getRecordSize()) {
			return -1;
		} else {
			return 0;
		}
	}
	/**
	 * ̃R[hwCp\ȃR[hTCYԂ
	 * @return R[hTCY
	 */
	public int getRecordSize() {
		return ((AvailableRecordByteStream)o).size;
	}
	/**
	 * ̗p\R[h̃oCgψʂԂ
	 * @return oCgψ
	 */
	public long getNextPtr() {
		return ((AvailableRecordByteStream)o).nextptr;
	}


	/**
	 * ̃R[h̃oCg\Ԃ
	 * @return oCg
	 */
	public byte[] byteStream() {
		byte[] bstream = o.byteStream();
		ByteBuffer buffer = ByteBuffer.allocate(bstream.length).order(ByteOrder.BIG_ENDIAN);
		buffer.put(bstream);						// i[f[^̃oCg(Œ蒷)
		
		return buffer.array();
	}
	/**
	 * oCg񂩂烌R[h𕜌
	 * @param bstream oCg
	 * @throws IllegalArgumentException oCg񂩂̕Ɏs
	 */
	protected void createObjectFromByteStream(byte[] bstream) throws IllegalArgumentException {
		o = new AvailableRecordByteStream(bstream);
	}
	/**
	 * R[hl̔r
	 * @param o rΏ
	 * @return true: / false:Ⴄ
	 */
	public boolean equals(Object o) {
		AvailableRecord r = (AvailableRecord)o;
		if(r == null) {
			// null̏ꍇ͎IɈႤƔf
			return false;
		}
		return getRecordSize() == r.getRecordSize() && getNextPtr() == r.getNextPtr();
	}

	class AvailableRecordByteStream implements ByteStream {
		private int size;
		private long nextptr;

		/**
		 * RXgN^
		 * @param s TCY
		 * @param n ̃R[h̃oCgψ
		 */
		public AvailableRecordByteStream(int s, long n) {
			size = s;
			nextptr = n;
		}
		/**
		 * RXgN^
		 * @param bstream oCg
		 */
		public AvailableRecordByteStream(byte[] bstream) {
			createObjectFromByteStream(bstream);
		}
		/**
		 * oCg񂩂烌R[h𕜌
		 * @param bstream oCg
		 * @throws IllegalArgumentException oCg񂩂̕Ɏs
		 */
		protected void createObjectFromByteStream(byte[] bstream) throws IllegalArgumentException {
			ByteBuffer buffer = ByteBuffer.allocate(bstream.length).order(ByteOrder.BIG_ENDIAN);
			buffer.put(bstream);
			buffer.rewind();
	
			size = buffer.getInt();
			// ̃R[h̃oCgψʂǂݎ
			nextptr = buffer.getLong();
		}
		/**
		 * oCgɕϊĕԂ
		 * @return oCg
		 */
		public byte[] byteStream() {
			ByteBuffer buffer = ByteBuffer.allocate(4+8).order(ByteOrder.BIG_ENDIAN);
			buffer.rewind();
			buffer.putInt(size);
			buffer.putLong(nextptr);
			return buffer.array();
		}
	}
}
