/**
 * LOGICAL-PARADOX.ORG variable record manager library
 * Copyright (C)2004 satoshi akabane(akabane@logical-paradox.org)
 *
 * Release 1.0
 * Ep[W
 */
package org.logical_paradox.common.vrm;

import java.util.Hashtable;

/**
 * R[h𐶐t@Ng
 * 
 * @author satoshi akabane@logical-paradox.org
 * @version 1.0
 */
public abstract class RecordFactory {
	public static final String DEFAULT_RECORD_FACTORY_CLASS_NAME = "org.logical_paradox.common.vrm.DefaultRecordFactory";
	public static final String DEFAULT_RECORD_FACTORY_PROPERTY_NAME = "org.logical_paradox.common.vrm.RecordFactoryClass";
	private static final Hashtable factoryPool = new Hashtable();

	/**
	 * RXgN^
	 * ftHgRXgN^KvȂ̂ŁCdȂ
	 */
	protected RecordFactory() {
	}
	/**
	 * ftHgt@Ng̃CX^XԂ
	 * @return ftHgt@Ng
	 */
	public static final RecordFactory getInstance() throws Exception {
		return RecordFactory.getInstance(DEFAULT_RECORD_FACTORY_CLASS_NAME);
	}
	/**
	 * t@Ng̃CX^XԂ
	 * @param classname
	 * @return t@Ng
	 * @throws Exception t@Ng̐Ɏs
	 */
	public static final RecordFactory getInstance(String classname) throws Exception {
		RecordFactory factory = (RecordFactory)factoryPool.get(classname);
		if(factory != null) {
			return factory;
		}
		
		// t@Ngv[Ɏw肳ꂽt@Ng̃CX^XȂ̂ŁCV
		factory = (RecordFactory)Class.forName(classname).newInstance();
		// t@Ngv[ɓo^
		factoryPool.put(classname, factory);

		return factory;
	}
	
	/**
	 * oCg񂩂烌R[h𐶐ĕԂ
	 * @param bstream
	 * @return
	 */
	public abstract Record getRecord(byte[] bstream);
}
